"use strict";
const gulp = require('gulp');
const sass = require('gulp-sass');
const paths = require('./paths');
const gulpsync = require('gulp-sync');
const cleanCSS = require('gulp-clean-css');
const sourcemaps = require('gulp-sourcemaps');
const watch = require('gulp-watch');

const sync = gulpsync(gulp).sync;

gulp.task('build:sass', sync(['build:app-sass', 'build:styles-sass']));

gulp.task('build:app-sass', ['copy:fonts'], function() {
    return gulp.src(paths.sourceSass)
        .pipe(sourcemaps.init())
        .pipe(sass().on('error', sass.logError))
        .pipe(cleanCSS())
        .pipe(sourcemaps.write('.'))
        .pipe(gulp.dest(paths.destPath));
});

gulp.task('build:styles-sass', function() {
    return gulp.src([paths.sassFiles, paths.sassNotLibFiles])
        .pipe(sourcemaps.init())
        .pipe(sass().on('error', sass.logError))
        .pipe(cleanCSS())
        .pipe(sourcemaps.write('.'))
        .pipe(gulp.dest(paths.stylesPath));
});

gulp.task('copy:fonts', function() {
    gulp.src(paths.fontFiles)
        .pipe(gulp.dest(paths.styleFontsPath));
});

gulp.task('watch:app-sass', function() {
    watch(paths.sourceSass, {verbose: true})
        .pipe(sourcemaps.init())
        .pipe(sass().on('error', sass.logError))
        .pipe(cleanCSS())
        .pipe(sourcemaps.write('.'))
        .pipe(gulp.dest(paths.destPath));
});

gulp.task('watch:styles-sass', function() {
    watch(paths.sassFiles, {verbose: true})
        .pipe(sourcemaps.init())
        .pipe(sass().on('error', sass.logError))
        .pipe(cleanCSS())
        .pipe(sourcemaps.write('.'))
        .pipe(gulp.dest(paths.stylesPath));
});