var gulp = require('gulp');
var del = require('del');

var cleaner = module.exports = {
    baseFolder: '.',
    appFolder: '/app',
    jspmFolder: '/jspm_packages',
    npmFolder: '/node_modules',
    stylesFolder: '/styles',
    coverageFolder: '/coverage',
    publishFolder: '/publish',
    e2eFolder: '/e2e_results',

    clean: function(folderName) {
        return new Promise((resolve) => {
            del.sync(folderName, {force: true});
            resolve();
        });
    }
};

gulp.task('clean:app', ['clean:service-worker'], function() {
    return cleaner.clean(cleaner.baseFolder + cleaner.appFolder);
});

gulp.task('clean:jspm', function() {
    return cleaner.clean(cleaner.baseFolder + cleaner.jspmFolder);
});

gulp.task('clean:npm', function() {
    return cleaner.clean(cleaner.baseFolder + cleaner.npmFolder)
});

gulp.task('clean:styles', function() {
    return cleaner.clean(cleaner.baseFolder + cleaner.stylesFolder);
});

gulp.task('clean:coverage', function() {
    return cleaner.clean(cleaner.baseFolder + cleaner.coverageFolder);
});

gulp.task('clean:publish', function() {
    return cleaner.clean(cleaner.baseFolder + cleaner.publishFolder);
});

gulp.task('clean:tests-base', function() {
    return cleaner.clean('gulp-tests');
});

gulp.task('clean:e2e-results', function() {
    return cleaner.clean(cleaner.baseFolder + cleaner.e2eFolder);
});

gulp.task('clean:all', ['clean:app', 'clean:jspm', 'clean:npm', 'clean:styles', 'clean:coverage', 'clean:publish']);

