const gulp = require('gulp');
const gulpSync = require('gulp-sync')(gulp);
const run = require('gulp-run');
const through2 = require("through2");
const fs = require("fs");

function setPackageJSPM(file, encoding, callback) {
    var object = JSON.parse(String(file.contents));
    var result = file;

    object.jspm = {
        "dependencies": {
            "aurelia-bootstrapper": "npm:aurelia-bootstrapper@^1.0.0",
            "aurelia-framework": "npm:aurelia-framework@^1.0.1"
        },
        "devDependencies": {}
    };

    var stringResult = JSON.stringify(object, null, '\t');

    result.contents = new Buffer(stringResult);
    this.push(result);
    callback();
}

function writeContent(file, content) {
    fs.writeFileSync(file, content);
}

gulp.task('init:copyFiles', function() {
    return gulp.src('node_modules/build-utilities/dist/**/*.*')
        .pipe(gulp.dest('.', {overwrite: true}));
});

gulp.task('init:jspm_install', function() {
    return run('jspm install -y').exec();
});

gulp.task('init:package_jspm', function() {
    return gulp.src('./package.json')
        .pipe(through2({objectMode: true}, setPackageJSPM))
        .pipe(gulp.dest('.'));
});

gulp.task('init:ignore', function() {
   const content = `
node_modules
jspm_packages
styles
app
coverage
`;
    writeContent(".gitignore", content);
});

gulp.task('init:babelrc', function() {
    const content = `
{
  "plugins": ["transform-decorators-legacy", "transform-decorators", "transform-class-properties"],
  "presets": ["es2015"]
}`;

    writeContent(".babelrc.old", content);
});

gulp.task('init-project', gulpSync.sync(['init:ignore', 'init:babelrc', 'init:copyFiles', 'init:package_jspm', 'init:jspm_install', 'package:set-scripts', 'build:all', 'serve']));