const gulp = require("gulp");
const through2 = require("through2");

function addScripts(file, encoding, callback) {
    var object = JSON.parse(String(file.contents));
    var result = file;

    if (!object.scripts) {
        object.scripts = {}
    }

    object.scripts["audit"] = "gulp clean:coverage && gulp audit:all && gulp test:coverage && gulp build:all && gulp test:e2e && gulp test:generate-report && gulp serve:coverage-report";
    object.scripts["test"] = "gulp test";
    object.scripts["test:ui"] = "gulp build:all && gulp test:e2e";
    object.scripts["build"] = "gulp build:all";
    object.scripts["watch:ui"] = "gulp build:all && gulp watch:ui";
    object.scripts["watch:all"] = "gulp build:all && gulp watch:all";
    object.scripts["run"] = "gulp build:all && gulp serve";

    var stringResult = JSON.stringify(object, null, '\t');

    result.contents = new Buffer(stringResult);
    this.push(result);
    callback();
}

gulp.task("package:set-scripts", function() {
    gulp.src("package.json")
        .pipe(through2({objectMode: true}, addScripts))
        .pipe(gulp.dest("."));
});